(* 
  Lambda Cube 

  Core module of the interpreter where type checking (except to R and RG) and 
  evaluation of expressions takes place. 
  
  author: Christian Mueller
*)

local 
    open AbstractSyntax LCSupport Info Support
in

exception Error of string
exception ErrorWInfo of info * (mixture list)
exception NoFurtherEval 

val setTypingMode : mode -> unit

val isval   : Exp -> bool
val equiv   : Exp * Exp -> bool
val subtype : Exp list -> Exp * Exp -> bool

val eval         : Exp -> Exp
val onestep_eval : Exp -> Exp

val check        : Exp -> Exp

end
