(* 
   signature of PP for nice output of internal syntax 
   
   author: Christian Mueller
*)

(* set and get output modes of the pretty printer *)
val setPrintMode : AbstractSyntax.pp_mode -> unit
val setPrintOutput : AbstractSyntax.pp_output -> unit
val getPrintOutput : unit -> AbstractSyntax.pp_output
val setLineWidth : int -> unit
			  
(* operate on the pretty printer stream *)
			  
(* clears the print buffer *)                   
val ppflush : unit -> unit  
		      
(* adds a string to the internal buffer *)
val pprint : string -> unit 
		       
(* outputs a string on stdout *)
val pp : AbstractSyntax.Exp -> unit 	
			       
(* same as pp tries in addition to synchronize with type decls in 
 the environment *)
val pplc : Environment.env -> AbstractSyntax.Exp -> unit 	
						    
(* marks the redex in stepping mode *)
val pplcwredex : Environment.env -> AbstractSyntax.Exp -> 
                 AbstractSyntax.Exp -> unit

