(***************************************

This implements a store for imperative
variables.

author: Christian Mueller

***************************************)

local 
    open AbstractSyntax Dynarray
in

val counter = ref ~1

val store = array(10,NONE) : Exp option array

fun newref e = (counter := !counter + 1; 
		update(store,!counter,SOME e);
		!counter)

fun assign r e = 
    if r <= !counter then update(store,r,SOME e)
    else raise Fail "! write access to an uninitialized store field"

fun read r = 
    if r <= !counter then
	(case sub(store,r) of
	     NONE => raise Fail "! read access to an uninitialezed store field"
	   | SOME e => e)
    else raise Fail "! read access to an uninitialezed store field"

end