(* -*-sml-*- *)

(* --------------------------------------------------------------------
 * This file contains some test cases for the interpreter in "Fw" mode. 
 * Further tests can be found in "s_test.f" and "f_test.f".
 *
 * author: Christian Mueller
 * -------------------------------------------------------------*)     

switch tm fw

(* 1. encoding polymorphic lists, cf. TAPL p.351 *)

def List = \X. \/ R. (X->R->R)->R->R (* def operator *)

rdef nil = \X.(\R.\c:X->R->R. \n:R. n) as (List X)

rdef isnil = \X.\l:List X. l Bool (\hd:X.\tl:Bool.false) true

rdef cons = \X.\hd:X.\tl:List X. (\R.\c:X->R->R.\n:R. c hd (tl R c n)) 
			      as (List X)

rdef head = \X.\default:X.\l: List X. l X (\hd:X.\tl:X.hd) default 

rdef tail = \X.\l:List X. (l {fst:List X,snd:List X}
			    (\hd:X.\tl:{fst:List X,snd:List X}.
                            {fst = tl@snd, snd = cons X hd (tl@snd) }) 
			    {fst = nil X, snd = nil X})@fst

rdef append = \X.\l1:List X.\l2:List X. 
                    l1 (List X) (\hd:X.\tl:List X. cons X hd tl) l2

rdef c = cons Int 
rdef hd = head Int ~1 
rdef tl = tail Int

rdef l1 = c 1 (nil Int)
rdef l2 = c 2 (c 3 (c 4 (nil Int))) 

rdef result_11 = append Int l1 l2 
rdef result_12 = hd (nil Int) 
rdef result_13 = hd (tl (tl result_11))


(* 2. church encoding for ADT for pairs *)

def TConstr = \P:*->*->*. \/X.\/Y.X->Y->P X Y
def TFirst  = \P:*->*->*. \/X.\/Y.P X Y->X
def TSecond = \P:*->*->*. \/X.\/Y.P X Y->Y

def Sig = \Z.\/P:*->*->*.TConstr P -> TFirst P -> TSecond P -> Z               

rdef pairADT = 
     \Z.\f:Sig Z.
          f (\X.\Y.\/Z'.(X->Y->Z') -> Z')
            (\X.\Y.\x:X.\y:Y. \Z'.\f:X->Y->Z'.f x y)   (* pair constructor *) 
            (\X.\Y.\p:\/Z'.(X->Y->Z')->Z'. p X (\x:X.\y:Y.x))     (* first *) 
            (\X.\Y.\p:\/Z'.(X->Y->Z')->Z'. p Y (\x:X.\y:Y.y))    (* second *) 

rdef client = \P:*->*->*.\constr:TConstr P.\first:TFirst P.\second:TSecond P.
             (\pair:P Int Int. (first Int Int pair) + second Int Int pair)
	             (constr Int Int 12 23)

rdef result_2 = pairADT Int client


