(*-*-sml-*-*)

(* --------------------------------------------------------------
 * This file contains some test cases for the interpreter
 * concerning references. References are not treated seperate
 * in Cubint. However in order not to mess the other test files
 * they are sourced out to this extra file.
 *
 * author: Christian Mueller
 * -------------------------------------------------------------*)

(* definition and usage of a reference *)

def r = ref 3

rdef x = (!r) + 2

rdef u = (r := 3+4; !r)

(* 
   define imperative objects
   compare TAPL, chapter 18
*)

def CounterRep = {x : Ref Int}

def Counter = {get:Unit->Int, set:Int->Unit, inc:Unit->Unit}

def counterClass =
	\r:CounterRep.
	   fix
	    (\self : Counter.
	       { get = \z:Unit. !(r@x),
		 set = \i:Int. r@x := i,
		 inc = \z:Unit. self@set ( (self@get unit) + 1) } )

def newCounter =
	\z:Unit. counterClass {x=ref 1}

(* use the counter object *)

rdef my_counter = newCounter unit

rdef result_11 = (my_counter@inc unit; my_counter@get unit)

rdef result_12 = (my_counter@set 33; my_counter@get unit)
